var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "uds-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};


function storeSubParameter(path, value) {
    Property.setProperty('/scripts/user-defined-states/' + path, value);
    Property.setFlag('/scripts/user-defined-states/' + path, 'ARCHIVE', true);
}

function getNewIdValue() {
    var idValue = Math.floor(new Date().getTime()/1000);
    var baseNode = Property.getNode('/scripts/user-defined-states/entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function storeValue(sParameterString) {
    try {
        var oParameterObject = JSON.parse(unescape(sParameterString));

        var idValue = null;
        if (oParameterObject.id != null)
            idValue = oParameterObject.id;
        else
            idValue = getNewIdValue();

        var esName = "" + idValue;

        var baseNode = Property.getNode('/scripts/user-defined-states/entries');
        if (baseNode != null)
            baseNode.removeChild(esName);
        
        storeSubParameter('entries/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter('entries/' + esName + '/id', esName);

        Property.store();
    } catch (e) {
    	lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
        	lWarn.logln(i + ': ' + e[i]);
        }

    }
}

function storeSensorState(sParameterString) {
	try {
    	var oParameter = JSON.parse(unescape(sParameterString));
    	var activeString=oParameter.activate;
    	var inactiveString=oParameter.inactive;
    	var sensorType=parseInt("" + oParameter.sensorType,10);
    	var stateName=null;
    	if (oParameter.zoneID) {
    		var groupID=parseInt("" + oParameter.groupID);
    		var oZone=getZoneByID(parseInt("" + oParameter.zoneID,10));
    		stateName=oZone.addStateSensor(groupID,sensorType,activeString,inactiveString);
    	} else if (oParameter.dsid) {
    		var oDevice=getDevices().byDSUID(oParameter.dsid);
    		stateName=oDevice.addStateSensor(sensorType,activeString,inactiveString);
    	}
		lInfo.logln('got ' + stateName);
		if (stateName!=null) {
	        storeSubParameter('sensors/' + stateName + '/name', Utf8.encode(unescape(oParameter.name)));
	        storeSubParameter('sensors/' + stateName + '/id', stateName);
			if (oParameter.zoneID) {
				storeSubParameter('sensors/' + stateName + '/group',oParameter.groupID);
				storeSubParameter('sensors/' + stateName + '/zone',oParameter.zoneID);
				storeSubParameter('sensors/' + stateName + '/sensorType',sensorType);
				storeSubParameter('sensors/' + stateName + '/activeValue',activeString);
				storeSubParameter('sensors/' + stateName + '/inactiveValue',inactiveString);
	    	} else if (oParameter.dsid) {
	    		storeSubParameter('sensors/' + stateName + '/dsid',oParameter.dsid);
	    		storeSubParameter('sensors/' + stateName + '/sensorType',sensorType);
				storeSubParameter('sensors/' + stateName + '/activeValue',activeString);
				storeSubParameter('sensors/' + stateName + '/inactiveValue',inactiveString);
	    	}
			Property.store();
		}

		
	} catch (e) {
		lWarn.logln("Fehler beim Speichern: " + e);
	    for ( var i in e) {
	    	lWarn.logln(i + ': ' + e[i]);
	    }
	
	}
}


function syncStates () {
    var baseNode = Property.getNode('entries');
    if (baseNode!=null) {
	    var oStates=baseNode.getChildren();
	    lInfo.logln("UDS-Config #" + oStates.length  + " von " + oStates);
		for (var iIndex=0;iIndex<oStates.length;iIndex++) {
			var oStateNode=oStates[iIndex];
			lInfo.logln("UDS-Config #" + oStateNode.getPath()  + " von " + oStates.length);
			var sID=oStateNode.getChild('id').getValue();
			lInfo.logln("prop "+ sID+" values " + Property.getProperty('/usr/addon-states/user-defines-states/uds_' + sID));
			if (Property.getProperty('/usr/addon-states/user-defines-states/uds_' + sID)==null) {
				lInfo.logln("register ding");
				registerState('uds_' + sID,true);
			}
		}
    }
	baseNode = Property.getNode('sensors');
	if (baseNode!=null) {
		var oSensorStates=baseNode.getChildren();
	    lInfo.logln("UDS-Config Sensor#" + oSensorStates.length);
		for (var iIndex=0;iIndex<oSensorStates.length;iIndex++) {
			var oStateNode=oSensorStates[iIndex];
			lInfo.logln("UDS-Config #" + oStateNode.getPath() );
			var sID=oStateNode.getChild('id').getValue();
	
			if (Property.getProperty('/usr/addon-states/user-defines-states/' + sID)==null) {
				lInfo.logln("register sensor ding");
				var sensorType=oStateNode.getChild('sensorType').getValue();
				var activeString=oStateNode.getChild('activeValue').getValue();
				var inactiveString=oStateNode.getChild('inactiveValue').getValue();
				if (oStateNode.getChild('zone')!=null) {
					var zoneID=parseInt(''+oStateNode.getChild('zone').getValue(),10);
					var groupID=parseInt(''+oStateNode.getChild('group').getValue(),10);
					var oZone=getZoneByID(zoneID);
		    		stateName=oZone.addStateSensor(groupID,sensorType,activeString,inactiveString);
		    		lInfo.logln('restored as ' + stateName);
				} else {
					var dsid=oStateNode.getChild('dsid').getValue();
					var oDevice=getDevices().byDSUID(dsid);
		    		stateName=oDevice.addStateSensor(sensorType,activeString,inactiveString);
		    		lInfo.logln('restored as ' + stateName);
				}
	
			}
		}
	}
}

lInfo.logln("UDS-Config " + raisedEvent.name);
if (raisedEvent.name == 'user-defined-states.config') {
	Property.load();
	lInfo.logln("UDS-Config param action " + raisedEvent.parameter.actions);
	if (raisedEvent.parameter.actions == 'generateSensorState') {
    	lInfo.logln("UDS-SensorState param value " + raisedEvent.parameter.value);
		storeSensorState(raisedEvent.parameter.value);
        var evt = new Event("user-defined-states.event", {}).raise();
        syncStates();
	}
    if (raisedEvent.parameter.actions == 'save') {
    	lInfo.logln("UDS-Config param value " + raisedEvent.parameter.value);
        storeValue(raisedEvent.parameter.value);
        Property.store();
        var evt = new Event("user-defined-states.event", {}).raise();
        syncStates();
    }  
    if (raisedEvent.parameter.actions == 'delete') {
    	lInfo.logln("UDS-Config delete value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
            var baseNode = Property.getNode('/scripts/user-defined-states/entries');
            if (baseNode != null)
                baseNode.removeChild(oIDObject[sKey]);        	
            var baseNode = Property.getNode('/scripts/user-defined-states/sensors');
            if (baseNode != null)
                baseNode.removeChild(oIDObject[sKey]);        	
            try {
            	unregisterState(oIDObject[sKey]);
            }
            catch (e) {
            	
            }
        }

        Property.store();
        var evt = new Event("user-defined-states.event", {});
        evt.raise();
    }
} else if (raisedEvent.name == 'running') {
    Property.load();
    syncStates();
}
